/* 
  driver - by The Last Viking  (C) 22. May 1997 Ekran Design.
  using ncurses...

  compile with: gcc -O -lncurses -lm driver.c -odriver
*/

#include <ncurses.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define false 1
#define true 0

int xite,cnt,gover,padx,fsync;
int hiscore,sc;
int gdir;

int road[30][2];

char ch;
struct _win_st wp;

int rnd(int i) {return (1+(int)(((float)i*rand())/(RAND_MAX-1)+1));}

void intro(void) {

 int xintr;
 int x,y,x2,y2,xo,yo;
 double dcnt,xd,yd;

 xintr=false;
 xo=0; yo=0;
 dcnt=0; cnt=0;
  do {
    if (cnt==1250) {cnt=0;dcnt=0;}
    mvprintw(8,35,"             ");
    mvprintw(10,20,"Written by The Last Viking 22. May 1997");
    mvprintw(12,19,"mission:  drive the car as far as you can");
    mvprintw(13,25,"use the z or the x key to steer");
    mvprintw(14,26,"use e to exit and s to start");
    mvprintw(16,32,"Last score: %d",sc);
    if (hiscore<sc) hiscore=sc;
    mvprintw(17,31,"Highest score: %d",hiscore);
    dcnt=dcnt+0.005; 
    xd=(cos(dcnt)*30);
    yd=(sin(dcnt)*12);
    x=35+(int)xd; y=12+(int)yd;
    x2=35-(int)xd; y2=12-(int)yd;
    if ((x2!=xo) || (y2!=yo)) mvprintw(yo,xo-1,"              ");
    mvprintw(y,x,"DRIVER"); 
    xo=x2;yo=y2; 
    ch='a';
    ch=(char)getch();
    if (ch=='s') {xintr=true; xite=false; gover=false;}
    if (ch=='e') {xintr=true; xite=true; gover=false;}
    timeout(0);
  } while (xintr==false);
}

void keys(void) { 
  ch=(char)getch();
  if (((ch=='z') || (ch=='Z')) && (padx>1)) {
     mvprintw(4,padx," ");
     mvprintw(5,padx," ");
     padx--;
     mvprintw(4,padx,"M");
     mvprintw(5,padx,"W");
  }
  if (((ch=='x') || (ch=='X')) && (padx<76)) {
     mvprintw(4,padx," ");
     mvprintw(5,padx," ");
     padx++;
     mvprintw(4,padx,"M");
     mvprintw(5,padx,"W");
  }

  if (ch=='q') gover=true;
  if (ch=='e') xite=true;
}

void roadhandler(void){
 for (cnt=1; cnt<26; cnt++) { /* erase road */
    mvprintw(road[cnt][0],road[cnt][1]," ");
    mvprintw(road[cnt][0],road[cnt][1]+8," ");
 }
 
 for (cnt=1; cnt<26; cnt++) road[cnt][1]=road[cnt+1][1];

 if ((rnd(1000)>500-gdir) && (road[26][1]<68)) road[26][1]++;
 if ((rnd(1000)>500+gdir) && (road[26][1]>2)) road[26][1]--;
 if (road[26][1]<12) gdir=150;
 if (road[26][1]>58) gdir=-150;

 for (cnt=1; cnt<26; cnt++) { /* draw road */
    mvprintw(road[cnt][0],road[cnt][1],"X");
    mvprintw(road[cnt][0],road[cnt][1]+8,"X");
 }
}

void collision(void) {
 if ((road[5][1]==padx) || (road[5][1]+8==padx)) gover=true;
 if ((road[4][1]==padx) || (road[4][1]+8==padx)) gover=true;
}

void main(void) {
 wp=*initscr(); /* initialize curses */
 cbreak();
 noecho();
 nonl();
 intrflush(stdscr, FALSE);
 keypad(stdscr, TRUE);
 nodelay(stdscr,TRUE);
 curs_set(0);
 hiscore=0;
 do {
   clear();
   intro();
   clear();
   sc=0; cnt=0;
   ch='.'; padx=38;
   mvprintw(4,padx,"M");
   mvprintw(5,padx,"W");
   sc=0;
   for (cnt=1; cnt<30; cnt++) {road[cnt][0]=cnt;road[cnt][1]=padx-2;}
   gdir=150;
   do {
     fsync=false;
     keys();
     roadhandler();
     collision();
     mvprintw(0,0,"Score: %d",sc);
     timeout(100);
     sc++;
   } while ((gover==false) && (xite==false));
 } while (xite==false);

 clear();
 printw("bye.");
 wrefresh(&wp);
 endwin();
}

